<template lang="pug">
b-table( :columns='columns' :data='cars' :loading='loading' @click='emit("select", $event)' )
	template( v-slot:image='{ item }' )
		img( v-if='m(item.Images)' :src='`${url}/cars/${m(item.Images).name}.webp`' crossorigin="use-credentials" )
	template( v-slot:brand='{ item }' ) {{ item.Brand.name }}
	template( v-slot:active='{ item }' )
		span.icon.is-small.has-text-success( v-if='item.active' )
			i.fa-solid.fa-check-square
		span.icon.is-small.has-text-danger( v-else )
			i.fa-solid.fa-xmark-square
	template( v-slot:buttons='{ item }' )
		.buttons
			b-button( type="danger" size="small" @click='cs.deleteCar(item.id)' )
				span.icon.is-small
					i.fa-solid.fa-trash-can
			b-button( node="router-link" :to='{ name: "Car", params: { id: item.id } }' type="link" size="small" )
				span.icon.is-small
					i.fa-solid.fa-arrow-right
</template>

<script setup>
import BTable from "@/components/table/Table.vue"

import { useCarStore } from "@/stores/car"
import { computed } from "vue"
import { useI18n } from "vue-i18n"

const props = defineProps({
	cars: {
		type: Array,
		default: () => []
	},
	loading: Boolean,
	buttons: Boolean
})

const emit = defineEmits([ "select" ])

const { t } = useI18n()
const cs = useCarStore()
const url = `//${import.meta.env.VITE_API_URI}`

const columns = computed(() => {
	const data = [ 
		{ field: "id", label: "ID" }, 
		{ field: "image", label: t("form.image") }, 
		{	field: "name", label: t("form.name") },
		{ field: "brand", label: t("form.brand") },
		{ field: "deposit", label: t("form.deposit"), format: "$" }, 
		{ field: "price", label: t("form.price"), format: "$" },
		{ field: "active", label: t("form.active") }
	]

	if (props.buttons)
		data.push({ field: "buttons" })

	return data
})

const m = imgs => imgs.find(({ main }) => !!main)
</script>

<style lang="scss" scoped>
	img {
		width: 9rem;
	}
</style>